define(["require", "exports", "react", "@fluentui/foundation-legacy", "./StackItem.styles"], function (require, exports, React, foundation_legacy_1, StackItem_styles_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var StackItemView = function (props) {
        var children = props.children;
        if (React.Children.count(children) < 1) {
            return null;
        }
        var Slots = foundation_legacy_1.getSlots(props, {
            root: 'div',
        });
        return foundation_legacy_1.withSlots(Slots.root, null, children);
    };
    exports.StackItem = foundation_legacy_1.createComponent(StackItemView, {
        displayName: 'StackItem',
        styles: StackItem_styles_1.StackItemStyles,
    });
    exports.default = exports.StackItem;
});
//# sourceMappingURL=StackItem.js.map